/* -*-Mode:C; tab-width:4; indent-tabs-mode:t; c-file-style:"bsd";-*- */
// $Id: task.h,v 1.13 2003/08/18 03:26:58 rick_price Exp $
#ifndef __TASK_H__
#define __TASK_H__

#include "progect.h"

// first usable index in db
#define FIRST_INDEX 0

// first usable level
#define FIRST_LEVEL 1
#define ACTION_DONE 10
#define ACTION_NOT_DONE 0
#define YEAR_OFFSET 1904 // for DateType
// Not used since 0.23, except in db conversion code
#define CNV_ACTION 11
#define CNV_ACTION_OK 12
#define CNV_ACTION_NO 13
#define CNV_INFORMATIVE 16 // informative type, set progress to this
#define CNV_NUMERIC 20     // numeric type, add to percentage when saving




// prototypes
// Tasks
void dbgPrintTask(DmOpenRef dbP, UInt16 index) TASKSECT;
pgErr    TaskSetAttr(DmOpenRef dbP, UInt16 index, TaskAttrType attr) 
	TASKSECT;
Boolean TaskGetAttr(DmOpenRef dbP, UInt16 index,TaskAttrType *attr)
	TASKSECT;
pgErr    TaskSetFormat(DmOpenRef dbP, UInt16 index, TaskFormatType format)
	TASKSECT;
TaskFormatType TaskGetFormat(DmOpenRef dbP, UInt16 index)
    TASKSECT;
pgErr    TaskSetLevel(DmOpenRef dbP, UInt16 index, UInt8 level) 
	TASKSECT;
UInt8    TaskGetLevel(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskSetPriority(DmOpenRef dbP, UInt16 index, UInt8 priority) 
	TASKSECT;
UInt8    TaskGetPriority(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskSetCategory(DmOpenRef dbP, UInt16 index, UInt16 category) 
	TASKSECT;
UInt16   TaskGetCategory(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskSetHasChild(DmOpenRef dbP, UInt16 index, Boolean hasChild) 
	TASKSECT;
Boolean  TaskGetHasChild(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskSetHasPrev(DmOpenRef dbP, UInt16 index, Boolean hasPrev) 
	TASKSECT;
Boolean  TaskGetHasPrev(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskSetHasNext(DmOpenRef dbP, UInt16 index, Boolean next) 
	TASKSECT;
Boolean  TaskGetHasNext(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
Boolean  TaskIsOpened(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
Boolean  TaskIsVisible(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
void TaskMakeVisible(DmOpenRef dbP, UInt16 index)
	TASKSECT;
Boolean  TaskToggleIsOpened(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskSetOpened(DmOpenRef dbP, UInt16 index, Boolean value) 
	TASKSECT;
UInt16   TaskGetFatherIndex(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
UInt16   TaskGetPrevIndex(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
UInt16   TaskGetPrevIndexByLevel(DmOpenRef dbP, UInt16 index, UInt8 level) 
	TASKSECT;
UInt16   TaskGetNextIndex(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
UInt16   TaskGetNextRelativeIndex(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskSetType(DmOpenRef dbP, UInt16 index, ItemType type)
	TASKSECT;
ItemType TaskGetType(DmOpenRef dbP, UInt16 index)
	TASKSECT;
UInt8    TaskGetCompleted(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskSetCompleted(DmOpenRef dbP, UInt16 index, UInt8 value, 
	Boolean dirty) 
	TASKSECT;
Boolean  TaskGetIsDone(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
Boolean  TaskGetActionState(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskSetDueDate(DmOpenRef dbP, UInt16 index, DateType date) 
	TASKSECT;
DateType TaskGetDueDate(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskSetNote(DmOpenRef dbP, UInt16 index, Char* note) 
	TASKSECT;
Char*    TaskGetNote(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
Char* TaskGetDescription(DmOpenRef dbP, UInt16 index)
	TASKSECT;
Char* TaskGetDescriptionByTaskPtr(TaskExtendedRecordType* pTask)
	TASKSECT;
pgErr TaskSetDescription(DmOpenRef dbP, UInt16 index, Char* desc)
	TASKSECT;
UInt32   TaskGetToDoUniqueID(DmOpenRef dbP, UInt16 index)
	TASKSECT;
pgErr    TaskInputDueDate(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskSave(UInt16 index) 
	TASKSECT;
pgErr    TaskGetSaved(UInt16 index) 
	TASKSECT;
pgErr    TaskRemoveSaved(void) 
	TASKSECT;
pgErr    TaskRemove(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr TaskRemoveChildren(DmOpenRef dbP, UInt16 index)
	TASKSECT;
pgErr    TaskRemoveDone(DmOpenRef dbP)
	TASKSECT;
pgErr    TaskRemoveDoneChildren(DmOpenRef dbP, UInt16 index)
	TASKSECT;
void TaskRemoveDeletedRecords(DmOpenRef dbP)
	TASKSECT;
pgErr    TaskExpand(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskCollapse(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskCalcCompleted(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskCalcCompletedAll(DmOpenRef dbP) 
	TASKSECT;
pgErr    TaskToRight(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskToLeft(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskUp(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskDown(DmOpenRef dbP, UInt16 index) 
	TASKSECT;
pgErr    TaskPublishToDo(DmOpenRef dbP, UInt16 index)
	TASKSECT;
pgErr    TaskGetToDoStatus(DmOpenRef dbP, UInt16 index, UInt8 *value, 
	                       UInt8 *priority, DateType *dueDate,
						   UInt16 *category)
	TASKSECT;
pgErr    TaskSetToDoStatus(DmOpenRef dbP, UInt16 index, UInt16 fields, 
						   UInt8 value, UInt16 priority, DateType dueDate,
						   UInt16 category)
	TASKSECT;
Err      TaskUpdateToDo(DmOpenRef dbP, UInt16 index)
	TASKSECT;
void     TaskSyncAll(void)
	TASKSECT;
pgErr    TaskRemoveHasToDo(DmOpenRef dbP, UInt16 index)
	TASKSECT;
pgErr    TaskRepairTree(DmOpenRef dbP, UInt16 start, UInt16 stop)
	TASKSECT;
pgErr    TaskToClipboard(DmOpenRef dbP, UInt16 index, Boolean withParent)
	TASKSECT;
UInt16   TaskFromClipboard(DmOpenRef dbP, UInt16 index, Boolean asChildren)
	TASKSECT;

Boolean QueryDeleteTask(DmOpenRef dbP, UInt16 taskToDelete)
	TASKSECT;
void TaskDeleteTree(DmOpenRef dbP, UInt16 taskToDelete)
	TASKSECT;
Boolean TaskGetDescriptionEmpty(DmOpenRef dbP, UInt16 index)
	TASKSECT;
#endif
